<template>
    <div class="profiles-list">
        <CreateProfile :submitForm="submitForm" :newProfile="newProfile" :countries="countries" />

        <div class="filters">
            <select class="filter-input" v-model="countryFilter" @change="applyFilters">
                <option value="">Все страны</option>
                <option v-for="country in countries" :key="country.id" :value="country.id">{{ country.title }}</option>
            </select>
            <input class="filter-input" v-model="emailFilter" placeholder="E-mail" @input="applyFilters"/>
        </div>

        <div class="table-wrapper">
            <table>
                <thead>
                <tr>
                    <th>ID</th>
                    <th>UID</th>
                    <th>Country</th>
                    <th>Name</th>
                    <th>Phone</th>
                    <th>Email</th>
                    <th>Card No</th>
                    <th>Card CVV</th>
                    <th>Comment</th>
                    <th>Actions</th>
                </tr>
                </thead>
                <tbody>
                <tr v-for="profile in profiles" :key="profile.id">
                    <td>{{ profile.id }}</td>
                    <td>{{ profile.uid }}</td>
                    <td>{{ profile.country?.title || 'N/A' }}</td>
                    <td>{{ profile.name }}</td>
                    <td>{{ profile.phone }}</td>
                    <td>{{ profile.email }}</td>
                    <td>{{ profile.card_no }}</td>
                    <td>{{ profile.card_cvv }}</td>
                    <td>{{ profile.comment }}</td>
                    <td>
                        <button @click="confirmDelete(profile)">Удалить</button>
                    </td>
                </tr>
                </tbody>
            </table>
        </div>
        <button @click="fetchProfiles(page - 1)" :disabled="page <= 1">Previous</button>
        <button @click="fetchProfiles(page + 1)" :disabled="!hasMorePages">Next</button>

        <ConfirmAction
            v-model:visible="showDeleteModal"
            :message="`Are you sure you want to delete the profile with email: ${profileToDelete?.email}?`"
            :action="deleteProfile"
        />
    </div>
</template>

<script>
import { ref, watch, onMounted } from 'vue';
import axios from 'axios';
import CreateProfile from '@/Components/CreateProfile.vue';
import ConfirmAction from '@/Components/ConfirmAction.vue';

export default {
    components: {
        CreateProfile,
        ConfirmAction
    },
    setup() {
        const profiles = ref([]);
        const page = ref(1);
        const hasMorePages = ref(false);
        const countryFilter = ref('');
        const emailFilter = ref('');
        const newProfile = ref({
            uid: '',
            country_id: '',
            email: '',
            name: '',
            phone: '',
            card_no: '',
            card_cvv: ''
        });
        const countries = ref([]);

        const showDeleteModal = ref(false);
        const profileToDelete = ref(null);

        const loadCountries = async () => {
            try {
                const response = await axios.get('/api/countries');
                countries.value = response.data;
            } catch (error) {
                console.error('Error loading countries:', error);
            }
        };

        const fetchProfiles = async (newPage = 1, resetPage = false) => {
            if (resetPage) {
                page.value = 1;
                newPage = 1;
            }
            const response = await axios.get('/api/profiles', {
                params: {
                    page: newPage,
                    country_id: countryFilter.value,
                    email: emailFilter.value
                }
            });
            profiles.value = response.data.data;
            page.value = newPage;
            hasMorePages.value = response.data.next_page_url !== null;
        };

        const submitForm = async () => {
            try {
                const response = await axios.post('/api/profiles', newProfile.value);
                profiles.value.unshift(response.data);
                newProfile.value = {
                    uid: '',
                    country_id: '',
                    email: '',
                    name: '',
                    phone: '',
                    card_no: '',
                    card_cvv: ''
                };
                fetchProfiles();
            } catch (error) {
                console.error('Error submitting form:', error);
            }
        };

        const confirmDelete = (profile) => {
            profileToDelete.value = profile;
            showDeleteModal.value = true;
        };

        const deleteProfile = async () => {
            try {
                await axios.delete(`/api/profiles/${profileToDelete.value.id}`);
                profiles.value = profiles.value.filter(profile => profile.id !== profileToDelete.value.id);
                showDeleteModal.value = false;
                profileToDelete.value = null;
            } catch (error) {
                console.error('Error deleting profile:', error);
            }
        };

        const applyFilters = () => {
            fetchProfiles(1, true);
        };

        watch(countryFilter, applyFilters);
        watch(emailFilter, applyFilters);

        onMounted(() => {
            loadCountries();
            fetchProfiles();
        });

        return {
            profiles,
            page,
            hasMorePages,
            countryFilter,
            emailFilter,
            newProfile,
            fetchProfiles,
            submitForm,
            confirmDelete,
            deleteProfile,
            showDeleteModal,
            profileToDelete,
            countries
        };
    }
};
</script>

<style scoped>
.table-wrapper {
    overflow-x: auto;
}
</style>
